﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr103_2
{
    // Класс с переопределением метода ToString(): 
    class MyClass
    {
        // Текстовое поле: 
        private String txt;

        // Конструктор:
        public MyClass(String t)
        {
            // Присваивание значения полю:
            txt = t;
        }

        // Метод вставки:
        public void MyInsert(String t, int index) {
            // Начало и конец исходной строки
            String start;
            String end;
            if (index > txt.Length || index < 0)
            {
                // Ошибочный индекс. Строку не меняем
                return;
            }
            else
            {
                // Разделяем строку по заданному индексу на
                // начало и конец
                start = txt.Substring(0, index);
                end = txt.Substring(index);
            }
            // Собираем строку
            txt = start + t + end;
        }

        // Переопределение метода ToString(): 
        public override String ToString()
        {
            // Возврат текстового поля: 
            return txt;
        }
    }

    // Класс с главным методом программы:
    class Program
    {
        static void Main()
        {
            // Вставка в конец строки
            String st1 = "паровоз";
            MyClass A = new MyClass(st1);
            A.MyInsert("ик", st1.Length);
            Console.WriteLine("Строка: \"{0}\", результат вставки в конец строки: \"{1}\"", st1, A);
            // Вставка в начало строки
            String st2 = "ход";
            MyClass B = new MyClass(st2);
            B.MyInsert("Тепло", 0);
            Console.WriteLine("Строка: \"{0}\", результат вставки в начало строки: \"{1}\"", st2, B);
            // Вставка в середину строки
            String st3 = "теплостанция";
            MyClass C = new MyClass(st3);
            C.MyInsert("электро", 5);
            Console.WriteLine("Строка: \"{0}\", результат вставки в середину строки: \n\"{1}\"", st3, C);
            // Ошибка. Индекс больше длины строки
            String st4 = "дом";
            MyClass D = new MyClass(st4);
            D.MyInsert("ик", 15);
            Console.WriteLine("Строка: \"{0}\", ошибочная позиция: 15, результат работы метода: \"{1}\"", st4, D);
            // Ошибка. Индекс отрицательный
            String st5 = "дом";
            MyClass E = new MyClass(st5);
            D.MyInsert("ик", -5);
            Console.WriteLine("Строка: \"{0}\", ошибочная позиция: -5, результат работы метода: \"{1}\"", st5, E);
            // Задержка:
            Console.ReadLine();
        }
    }
}
